<?php
/**
 * gMap
 *
 * @version 1.0
 * @package gMap
 * @author ZyX (allforjoomla.com)
 * @copyright (C) 2010 by ZyX (http://www.allforjoomla.com)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project,
 * please make a reference to allforjoomla.com someplace in your code
 * and provide a link to http://www.allforjoomla.com
 **/

defined('_JEXEC') or die( 'Restricted access' );



class HTML_strbm_admin {



	function listObjects($objects,$pageNav) {

		global $option,$my,$database,$cfgrab,$mosConfig_live_site,$mainframe;



		$filterType = (int)$mainframe->getUserStateFromRequest( "filter_type", 'filter_type', 0 );

		//$filterType = (int)JRequest::getVar('filter_type', '0', '', 'int');

		

		$types = strbmGetObjTypes();

		$list = array();

		$list[] = JHTML::_('select.option', 0, '### '._STRBM_ALL.' ###');

		$objTypes = array();

		$objTypes[0] = _STRBM_NO_ASIGNED;

		foreach($types as $type ){

			$list[] = JHTML::_('select.option', $type->id, $type->name);

			$objTypes[(int)$type->id] = $type->name;

		}

		$filter = JHTML::_('select.genericlist',  $list, 'filter_type', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', $filterType);

		JHTML::_('behavior.tooltip');

		?>

		<form action="index2.php" method="post" name="adminForm">

		<div style="margin:5px 0; text-align:right;"><?php echo _STRBM_FILTER_BY_TYPE.': '.$filter;?></div>

		<table cellspacing="1" class="adminlist">

		<thead>

		<tr>

		<th width="30">#</th>

		<th width="30"><input type="checkbox" name="toggle" value="" onClick="checkAll(<?php echo count( $objects ); ?>);" /></th>

		<th width="30" class="title">ID</th>

		<th align="left"><?php echo _STRBM_OBJ_NAME; ?></th>

		<th align="left"><?php echo _STRBM_OBJ_TYPE; ?></th>

		<th width="1%"><?php echo JHTML::_('grid.order',  $objects );?></th>

		<th width="60"><?php echo _STRBM_PUBLISHING; ?></th>

		<th width="150"><?php echo _STRBM_CREATED; ?></th>

		<th width="150"><?php echo _STRBM_MODIFIED; ?></th>

		</tr>

		</thead>

		<tbody>

		<?php

		$k = 0;

		$i = 0;

		for ($i=0, $n=count( $objects ); $i < $n; $i++) {

			$obj = $objects[$i];

			$checked 	= JHTML::_('grid.checkedout',   $obj, $i );

			$published 	= JHTML::_('grid.published', $obj, $i );

			?>

			<tr class="row<?php echo $k; ?>">

			<td align="center"><?php echo $i+$pageNav->limitstart+1;?></td>

			<td align="center">

			<?php 

			if($obj->checked_out && $obj->checked_out!=$my->id){

				echo JHTMLGrid::_checkedOut( $obj );

			}

			else echo $checked;?>

			</td>

			<td align="center"><?php echo $obj->id; ?></td>

			<td>

				<?php

				if($obj->checked_out && $obj->checked_out!=$my->id){

					echo $obj->obj_name;

				}

				else{?>

					<a href="index2.php?option=com_gmap&task=edit_obj&id=<?php echo $obj->id; ?>"><?php echo $obj->obj_name; ?></a>

				<?php }	?>

			</td>

			<td><?php echo $objTypes[(int)$obj->obj_type]; ?></td>

			<td align="center"><input type="text" name="order[]" size="5" value="<?php echo $obj->ordering; ?>" class="text_area" style="text-align: center" /></td>

			<td align="center"><?php echo $published;?></td>

			<td align="center"><?php echo $obj->created_by_alias.'<br/>'.JHTML::_('date',  $obj->created, '%d.%m.%Y %H:%M:%S' ); ?></td>

			<td align="center"><?php if($obj->modified_by==0){echo '---';} else{echo $obj->modified_by_alias.'<br/>'.JHTML::_('date',  $obj->modified, '%d.%m.%Y %H:%M:%S' );} ?></td>

			</tr>

			<?php

			$k = 1 - $k;

		}?>

		</tr>

		</tbody>

		</table>

		<div class="zxPagination"><?php echo $pageNav->getListFooter(); ?></div>

		<input type="hidden" name="option" value="<?php echo $option; ?>">

		<input type="hidden" name="task" value="list_vacancys">

		<input type="hidden" name="boxchecked" value="0">

		</form>

		<?php

	}

	

	function editObject($obj) {

		global $option;

		

		$types = strbmGetObjTypes();

		$list = array();

		$list[] = JHTML::_('select.option', 0, '### '._STRBM_NO_ASIGNED.' ###');

		foreach($types as $type ){

			$list[] = JHTML::_('select.option', (int)$type->id, $type->name);

		}

		$objTypes = JHTML::_('select.genericlist',  $list, 'obj_type', ' id="obj_type" class="inputbox" size="1"', 'value', 'text', (int)$obj->obj_type);

		

		JFilterOutput::objectHTMLSafe( $obj, ENT_QUOTES, 'full_info' );

		$editor 	=& JFactory::getEditor();

		$published = JHTML::_('select.booleanlist',  'published', 'class="inputbox"', ($obj->id?(int)$obj->published:1) );

		?>

		<script type="text/javascript">

		<!--

		function submitbutton(pressbutton) {

			if ( ( pressbutton == 'save_obj' || pressbutton == 'apply_obj' ) && ( document.adminForm.obj_name.value == "" ) ) {

				alert("<?php echo _STRBM_ENTER_OBJ_NAME; ?>");

			} else {

				<?php

					echo $editor->save( 'full_info' );

				?>

				submitform(pressbutton);

			}

		}

		//-->

		</script>

		<form action="index.php" method="post" name="adminForm" autocomplete="off">

		<div class="col width-55">

			<fieldset class="adminform">

			<legend><?php echo _STRBM_OBJECT_DATA; ?></legend>

				<table class="admintable" cellspacing="1" width="100%">

				<tr>

				<td width="150" class="key"><label for="obj_name"><?php echo _STRBM_OBJ_NAME; ?></label></td>

				<td><input type="text" name="obj_name" id="obj_name" class="inputbox" size="40" value="<?php echo $obj->obj_name; ?>" /></td>

				</tr>

				<tr>

				<td class="key"><label for="obj_address"><?php echo _STRBM_OBJ_ADDRESS; ?></label></td>

				<td><input type="text" name="obj_address" id="obj_address" class="inputbox" size="40" value="<?php echo $obj->obj_address; ?>" /></td>

				</tr>

				<tr>

				<td class="key"><label for="obj_type"><?php echo _STRBM_OBJ_TYPE; ?></label></td>

				<td><?php echo $objTypes;?></td>

				</tr>

				<tr>

				<td class="key"><label for="published"><?php echo _STRBM_PUBLISHING; ?></label></td>

				<td><?php echo $published;?></td>

				</tr>

				<tr>

				<td class="key"><label for="short_info"><?php echo _STRBM_SHORT_INFO; ?></label></td>

				<td><textarea name="short_info" id="short_info" class="inputbox" cols="40" rows="3"><?php echo $obj->short_info; ?></textarea></td>

				</tr>

				<tr>

				<td colspan="2">

					<strong><?php echo _STRBM_FULL_INFO; ?></strong><br/>

					<?php echo $editor->display( 'full_info', $obj->full_info, '100%', '400', '60', '20', array(/*'pagebreak', 'readmore'*/) ) ; ?>

				</td>

				</tr>

				</table>

			</fieldset>

		</div>

		<div class="col width-45">

			<fieldset class="adminform">

			<legend><?php echo _STRBM_PLACE_ON_MAP; ?></legend>

				<table class="admintable" width="100%">

					<tr>

						<td>

							<div id="google_map" style="width:100%;height:400px;"></div>

						</td>

					</tr>

				</table>

			</fieldset>

		</div>

		<div class="clr"></div>

		<script type="text/javascript" src="<?php echo $GLOBALS["cfgstrbmap"]['gmaps_url'].$GLOBALS["cfgstrbmap"]['gmaps_key'];?>"></script>

		<script language="javascript" type="text/javascript">

		function initialize(){

			if (GBrowserIsCompatible()) {

				var map = new GMap2(document.getElementById("google_map"));

				map.setCenter(new GLatLng(<?php echo $GLOBALS["cfgstrbmap"]['gmaps_def_coords'];?>), <?php echo $GLOBALS["cfgstrbmap"]['gmaps_def_zoom'];?>);

				//map.addControl(new GLargeMapControl());

				//map.addControl(new GMapTypeControl());

				map.setUIToDefault();

				

				var marker = new GMarker(<?php echo ($obj->obj_coords!=''?'new GLatLng('.$obj->obj_coords.')':'map.getCenter()');?>, {draggable: true});

		

				GEvent.addListener(marker, "dragstart", function() {

				  map.closeInfoWindow();

				});

		

				GEvent.addListener(marker, "dragend", function() {

				  var coords = marker.getLatLng().lat();

				  coords+= ', '+marker.getLatLng().lng();

				  var txt = "<?php echo _STRBM_OBJ_PLACED;?><br/>"+coords;

				  if(saveCoords(coords)) marker.openInfoWindowHtml(txt);

				  else{

					 marker.setLatLng(<?php echo ($obj->obj_coords!=''?'new GLatLng('.$obj->obj_coords.')':'map.getCenter()');?>);

					 marker.openInfoWindowHtml("<?php echo _STRBM_OBJ_NOT_PLACED;?>");

				  }

				});

				map.addOverlay(marker);

				

				<?php

				if($obj->obj_coords!=''){

					?>

					window.setTimeout(function() {map.panTo(new GLatLng(<?php echo $obj->obj_coords;?>));}, 1000);

					<?php

				} ?>

			}

		}

		function saveCoords(coords){

			var obj = document.adminForm.obj_coords;

			if(obj){

				obj.value = coords;

				return true;

			}

			else return false;

		}

		window.setTimeout(function(){initialize();}, 1000);
		document.body.onload = function(){

			initialize();

		}

		document.body.onunload = function(){

			GUnload();

		}

		</script>

		<input type="hidden" name="id" value="<?php echo (int)$obj->id; ?>" />

		<input type="hidden" name="option" value="com_gmap" />

		<input type="hidden" name="task" value="" />

		<input type="hidden" name="ordering" value="<?php echo (is_null($obj->ordering)?99999:$obj->ordering); ?>" />

		<input type="hidden" name="obj_coords" value="<?php echo $obj->obj_coords; ?>" />

		<?php echo JHTML::_( 'form.token' ); ?>

		</form>

		<?php

	}

	

	function listTypes($types,$pageNav) {

		global $option,$my,$database,$cfgrab,$mosConfig_live_site;



		JHTML::_('behavior.tooltip');

		?>

		<form action="index2.php" method="post" name="adminForm">

		<table cellspacing="1" class="adminlist">

		<thead>

		<tr>

		<th width="30">#</th>

		<th width="30"><input type="checkbox" name="toggle" value="" onClick="checkAll(<?php echo count( $types ); ?>);" /></th>

		<th width="30">ID</th>

		<th width="30"><?php echo _STRBM_MARKER; ?></th>

		<th align="left"><?php echo _STRBM_NAME; ?></th>

		</tr>

		</thead>

		<tbody>

		<?php

		$k = 0;

		$i = 0;

		for ($i=0, $n=count( $types ); $i < $n; $i++) {

			$type = $types[$i];

			$checked 	= JHTML::_('grid.checkedout',   $type, $i );

			?>

			<tr class="row<?php echo $k; ?>">

			<td align="center"><?php echo $i+$pageNav->limitstart+1;?></td>

			<td align="center"><?php echo $checked;?></td>

			<td align="center"><?php echo $type->id; ?></td>

			<td align="center"><img src="<?php echo $mosConfig_live_site.$GLOBALS["cfgstrbmap"]["images_path"].'/'.$type->icon_name; ?>" /></td>

			<td>

				<a href="index2.php?option=com_gmap&task=edit_type&id=<?php echo $type->id; ?>"><?php echo $type->name; ?></a>

			</td>

			</tr>

			<?php

			$k = 1 - $k;

		}?>

		</tr>

		</tbody>

		</table>

		<div class="zxPagination"><?php echo $pageNav->getListFooter(); ?></div>

		<input type="hidden" name="option" value="<?php echo $option; ?>">

		<input type="hidden" name="task" value="list_vacancys">

		<input type="hidden" name="boxchecked" value="0">

		</form>

		<?php

	}

	

	function editType($obj) {

		global $option,$mosConfig_live_site;

		$folder = JPATH_SITE.$GLOBALS["cfgstrbmap"]["images_path"];

		@chmod( $folder, 0766 );

		?>

		<script type="text/javascript">

		<!--

		function submitbutton(pressbutton) {

			if ( ( pressbutton == 'apply_type' || pressbutton == 'save_type' ) && ( document.adminForm.name.value == "" ) ) {

				alert("<?php echo _STRBM_ENTER_TYPE_NAME; ?>");

			} else {

				submitform(pressbutton);

			}

		}

		//-->

		</script>

		<?php

		if(!is_writable($folder)) echo '<dl id="system-message"><dd class="error fade"><ul><li>'._STRBM_UPLD_FOLDER_NOT_WRITABLE.'</li></ul></dd></dl>';

		?>

		<form action="index.php" method="post" name="adminForm" autocomplete="off" enctype="multipart/form-data">

			<table class="admintable" cellspacing="1">

			<tr>

			<td width="150" class="key"><label for="name"><?php echo _STRBM_NAME; ?></label></td>

			<td><input type="text" name="name" id="name" class="inputbox" size="40" value="<?php echo $obj->name; ?>" /></td>

			</tr>

			<tr>

			<td class="key"><?php echo _STRBM_MARKER; ?></td>

			<td><?php if($obj->icon_name) echo '<img src="'.$mosConfig_live_site.$GLOBALS["cfgstrbmap"]["images_path"].'/'.$obj->icon_name.'" align="absmiddle" /> ';?><input type="file" name="upld[icon_name]" /></td>

			</tr>

			<tr>

			<td class="key"><?php echo _STRBM_MARKER_SHADOW; ?></td>

			<td><?php if($obj->icon_shad_name) echo '<img src="'.$mosConfig_live_site.$GLOBALS["cfgstrbmap"]["images_path"].'/'.$obj->icon_shad_name.'" align="absmiddle" /> ';?><input type="file" name="upld[icon_shad_name]" /></td>

			</tr>

			<tr>

			<td class="key"><label for="icon_anchor"><?php echo _STRBM_ICON_ANCHOR; ?></label></td>

			<td><input type="text" name="icon_anchor" id="icon_anchor" class="inputbox" size="5" value="<?php echo $obj->icon_anchor; ?>" /></td>

			</tr>

			<tr>

			<td class="key"><label for="info_win_anchor"><?php echo _STRBM_WIN_ANCHOR; ?></label></td>

			<td><input type="text" name="info_win_anchor" id="info_win_anchor" class="inputbox" size="5" value="<?php echo $obj->info_win_anchor; ?>" /></td>

			</tr>

			</table>

		<input type="hidden" name="id" value="<?php echo (int)$obj->id; ?>" />

		<input type="hidden" name="option" value="com_gmap" />

		<input type="hidden" name="returnpage" value="list_obj_types" />

		<input type="hidden" name="task" value="" />

		<?php echo JHTML::_( 'form.token' ); ?>

		</form>

		<?php

	}



	function showConfig() {

		global $option;

		

		$cfgfile = JPATH_SITE.DS.'components'.DS.'com_gmap'.DS.'configuration.php';

		@chmod( $cfgfile, 0766 );

		?>

		<form action="index2.php" method="POST" name="adminForm">

		<?php

		if(!is_writable($cfgfile)) echo '<dl id="system-message"><dd class="error fade"><ul><li>'._STRBM_CONFIG_NOT_WRITABLE.'</li></ul></dd></dl>';

		?>

			<table cellpadding="2" cellspacing="4" border="0" width="100%" class="adminform">

			  <tr>

				 <td width="30%" valign="top"><?php echo _STRBM_IMGS_PATH; ?></td>

				 <td width="70%" valign="top"><input type="text" name="cfg[images_path]" value="<?php echo $GLOBALS['cfgstrbmap']['images_path']; ?>" class="inputbox" size="100" maxlength="150" /></td>

			  </tr>

			  <tr>

				 <td valign="top"><?php echo _STRBM_GMAPS_URL; ?></td>

				 <td valign="top"><input type="text" name="cfg[gmaps_url]" value="<?php echo $GLOBALS['cfgstrbmap']['gmaps_url']; ?>" class="inputbox" size="100" maxlength="150" /></td>

			  </tr>

			  <tr>

				 <td valign="top"><?php echo _STRBM_GMAPS_KEY; ?><div class="small"><?php echo _STRBM_GMAPS_KEY_INFO; ?></div></td>

				 <td valign="top"><input type="text" name="cfg[gmaps_key]" value="<?php echo $GLOBALS['cfgstrbmap']['gmaps_key']; ?>" class="inputbox" size="100" maxlength="150" /></td>

			  </tr>

			  <tr>

				 <td valign="top"><?php echo _STRBM_GMAPS_COORDS; ?></td>

				 <td valign="top"><input type="text" name="cfg[gmaps_def_coords]" value="<?php echo $GLOBALS['cfgstrbmap']['gmaps_def_coords']; ?>" class="inputbox" size="20" maxlength="20" /></td>

			  </tr>

			  <tr>

				 <td valign="top"><?php echo _STRBM_GMAPS_ZOOM; ?></td>

				 <td valign="top"><input type="text" name="cfg[gmaps_def_zoom]" value="<?php echo $GLOBALS['cfgstrbmap']['gmaps_def_zoom']; ?>" class="inputbox" size="2" maxlength="2" /></td>

			  </tr>

			</table>

		  <input type="hidden" name="task" value="" />

		  <input type="hidden" name="returnpage" value="list_objects" />

		  <input type="hidden" name="option" value="com_gmap" />

		</form>

		<?php 

   }

   

   



}

