<?php
/**
 * gMap
 *
 * @version 1.0
 * @package gMap
 * @author ZyX (allforjoomla.com)
 * @copyright (C) 2010 by ZyX (http://www.allforjoomla.com)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project,
 * please make a reference to allforjoomla.com someplace in your code
 * and provide a link to http://www.allforjoomla.com
 **/


defined( '_JEXEC' ) or die( 'Restricted access' );

if(!defined('_VALID_MOS')) define('_VALID_MOS',1);



$user	=& JFactory::getUser();

/*if (!$user->authorize( 'com_rabota', 'manage' )) {

	$mainframe->redirect( 'index.php', JText::_('ALERTNOTAUTH') );

}*/



$GLOBALS['mosConfig_live_site']		= substr_replace(JURI::root(), '', -1, 1);

$GLOBALS['mosConfig_absolute_path']	= JPATH_SITE;

$lang =& JFactory::getLanguage();

$GLOBALS['mosConfig_lang'] = $lang->getBackwardLang();



if (is_file( JPATH_SITE.DS.'components'.DS.'com_gmap'.DS.'language'.DS.$GLOBALS['mosConfig_lang'].'.php' ) ) require_once(JPATH_SITE.DS.'components'.DS.'com_gmap'.DS.'language'.DS.$GLOBALS['mosConfig_lang'].'.php'); 

else require_once(JPATH_SITE.DS.'components'.DS.'com_gmap'.DS.'language'.DS.'russian.php');



require_once( JPATH_SITE.DS.'components'.DS.'com_gmap'.DS.'configuration.php' );

require_once( JPATH_SITE.DS.'components'.DS.'com_gmap'.DS.'zxtemplate.php' );

require_once( JPATH_SITE.DS.'components'.DS.'com_gmap'.DS.'gmap.class.php' );

require_once( JPATH_SITE.DS.'components'.DS.'com_gmap'.DS.'gmap.functions.php' );

require_once( JApplicationHelper::getPath( 'admin_html' ) );



$conf =& JFactory::getConfig();

$GLOBALS['database'] = &JFactory::getDBO();

$GLOBALS['my'] = (object)$user->getProperties();

$GLOBALS['my']->gid	= $user->get('aid', 0);







$cid = JRequest::getVar( 'cid', array(), '', 'array' );

JArrayHelper::toInteger( $cid );

if (!is_array( $cid )) {

	$cid = array(0);

}

$npid = JRequest::getVar( 'npid', 0, '', 'int' );

$id = JRequest::getVar( 'id', 0, '', 'int' );

$task = JRequest::getCmd('task','list_objects');



switch ($task) {

	###################################

	case "apply_obj":

	case "save_obj":

		strbmSaveObj($id,$task);

	break;

	case "edit_obj":

		strbmEditObject($id);

	break;

	case "obj_cancel":

		strbmCancelObject($id);

	break;

	case "remove_object":

		strbmDelObjects($cid);

	break;

	case "publish":

		strbmObjPublish($cid);

	break;

	case "unpublish":

		strbmObjUnPublish($cid);

	break;

	###########################

	case "list_obj_types":

		strbmListTypes();

	break;

	case "edit_type":

		strbmEditType($id);

	break;

	case "apply_type":

	case "save_type":

		strbmSaveType($id,$task);

	break;

	case "remove_type":

		strbmDelTypes($cid);

	break;

	###########################

	case "saveorder":

		strbmSaveOrder($cid);

	break;

	case "save_config":

		strbmSaveConfig();

	break;

	case "cancel":

		strbmCancel();

	break;

	case "config":

		HTML_strbm_admin::showConfig();

	break;

	default:

		strbmListObjects();

	break;

}





function strbmListObjects(){

	global $database,$mosConfig_absolute_path,$option,$cfgrab,$mainframe,$cfgfile;



	$limit = $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', 20 );

	$limitstart = $mainframe->getUserStateFromRequest( "view{$option}limitstart",'limitstart', 0 );



	$filterType = (int)$mainframe->getUserStateFromRequest( "filter_type", 'filter_type', 0 );



	$where = array();

	

	if($filterType>0){

		$where[] = "obj_type='$filterType'";

	}



	$sql = "SELECT COUNT(*) FROM #__strb_objects";

	if(count($where)) $sql.= ' WHERE '.implode(' AND ',$where);

	$database->setQuery($sql);

	$total = $database->loadResult();



	require_once("includes/pageNavigation.php" );

	$pageNav = new mosPageNav( $total, $limitstart, $limit  );



	$sql = "SELECT * FROM #__strb_objects";

	if(count($where)) $sql.= ' WHERE '.implode(' AND ',$where);

	$sql.= " ORDER by ordering, created DESC";

	$database->setQuery($sql, $limitstart, $limit);

	$items = $database->loadObjectList();



	HTML_strbm_admin::listObjects($items,$pageNav);

}



function strbmEditObject($id) {

	global $database, $option, $mainframe;

	global $my;



	$row = new strbmObject($database);

	$row->load( $id );



	if ($row->checked_out && $row->checked_out != $my->id){

		$mainframe->redirect( "index2.php?option=$option&task=list_objects",strbmTemplate(_STRBM_OBJECT_IS_CHECKED_OUT,array('name'=>$row->obj_name)) );

	}

	

	if($row->id) $row->checkout( $my->id );



	HTML_strbm_admin::editObject($row);

}



function strbmSaveObj($id,$task) {

	global $database, $option,$my,$mainframe;

	

	$post	= JRequest::get( 'post' );

	

	$obj = new strbmObject($database);

	$obj->load($id);

	

	if (!$obj->bind( $post, 'selections' )) {

		return JError::raiseWarning( 500, $obj->getError() );

	}



	if (!$obj->check()) {

		return JError::raiseWarning( 500, $obj->getError() );

	}



	if ($obj->id) {

		$obj->modified = date( "Y-m-d H:i:s" );

		$obj->modified_by = $my->id;

		$obj->modified_by_alias = $my->name;

	} else {

		$obj->modified = '0000-00-00 00:00:00';

		$obj->modified_by = '0';

		$obj->modified_by_alias = '';

		$obj->created = date( "Y-m-d H:i:s" );

		$obj->created_by = $my->id;

		$obj->created_by_alias = $my->name;

	}

	

	if (!$obj->store()) {

		return JError::raiseWarning( 500, $obj->getError() );

	}

	$obj->checkin();

	

	if($task=='apply_obj') $mainframe->redirect( "index2.php?option=$option&task=edit_obj&id=".$obj->id, _STRBM_OBJ_SAVED );

	else $mainframe->redirect( "index2.php?option=$option&task=list_objects",_STRBM_OBJ_SAVED );

}



function strbmCancelObject($id) {

	global $option,$mainframe,$database;

	$obj = new strbmObject($database);

	$obj->load($id);

	$obj->checkin();

	$mainframe->redirect( "index2.php?option=$option&task=list_objects" );

}



function strbmDelObjects( &$cid ) {

	global $database, $option, $mainframe;



	if (count( $cid ) < 1) {

		echo "<script> alert('" . _STRBM_SEL_OBJECTS . "'); window.history.go(-1);</script>\n";

		exit;

	}

	$pids = implode( ',', $cid );

	$database->setQuery( "DELETE FROM #__strb_objects WHERE id IN ($pids)" );

	if (!$database->query()) {

		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";

	}



	$mainframe->redirect( "index2.php?option=$option&task=list_objects" );

}



function strbmSaveOrder($cid) {

	global $database,$mainframe,$option;



	$total		= count( $cid );

	$order = JRequest::getVar( 'order', array(), '', 'array' );

	JArrayHelper::toInteger( $order );



	$row		= new strbmObject( $database );

	$conditions = array();

	for( $i=0; $i < $total; $i++ ) {

		$row->load( (int) $cid[$i] );

		if ($row->ordering != $order[$i]) {

			$row->ordering = $order[$i];

			if (!$row->store()) {

				echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";

				exit();

			}

		} 

	} 



	$mainframe->redirect( "index2.php?option=$option&task=list_objects" );

} 



function strbmObjPublish($cid) {

	global $option,$mainframe,$database,$my;

	foreach($cid as $id){

		$obj = new strbmObject($database);

		$obj->load($id);

		if(!$obj->id){

			return JError::raiseWarning( 500, _STRBM_OBJ_NOT_FOUND );

		}

		if ($obj->checked_out && $obj->checked_out != $my->id){

			$mainframe->redirect( "index2.php?option=$option&task=list_objects",strbmTemplate(_STRBM_OBJECT_IS_CHECKED_OUT,array('name'=>$obj->obj_name)) );

		}

		$obj->published = 1;

		$obj->modified = date( "Y-m-d H:i:s" );

		$obj->modified_by = $my->id;

		$obj->modified_by_alias = $my->name;

		if (!$obj->store()) {

			return JError::raiseWarning( 500, $obj->getError() );

		}

	}

	$mainframe->redirect( "index2.php?option=$option&task=list_objects" );

}



function strbmObjUnPublish($cid) {

	global $option,$mainframe,$database,$my;

	foreach($cid as $id){

		$obj = new strbmObject($database);

		$obj->load($id);

		if(!$obj->id){

			return JError::raiseWarning( 500, _STRBM_OBJ_NOT_FOUND );

		}

		if ($obj->checked_out && $obj->checked_out != $my->id){

			$mainframe->redirect( "index2.php?option=$option&task=list_objects",strbmTemplate(_STRBM_OBJECT_IS_CHECKED_OUT,array('name'=>$obj->obj_name)) );

		}

		$obj->published = 0;

		$obj->modified = date( "Y-m-d H:i:s" );

		$obj->modified_by = $my->id;

		$obj->modified_by_alias = $my->name;

		if (!$obj->store()) {

			return JError::raiseWarning( 500, $obj->getError() );

		}

	}

	$mainframe->redirect( "index2.php?option=$option&task=list_objects" );

}



####################################



function strbmListTypes(){

	global $database,$mosConfig_absolute_path,$option,$cfgrab,$mainframe,$cfgfile;



	$limit = $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', 20 );

	$limitstart = $mainframe->getUserStateFromRequest( "view{$option}limitstart",'limitstart', 0 );

	$where = array();



	$sql = "SELECT COUNT(*) FROM #__strb_obj_types";

	if(count($where)) $sql.= ' WHERE '.implode(' AND ',$where);

	$database->setQuery($sql);

	$total = $database->loadResult();



	require_once("includes/pageNavigation.php" );

	$pageNav = new mosPageNav( $total, $limitstart, $limit  );



	$sql = "SELECT * FROM #__strb_obj_types";

	if(count($where)) $sql.= ' WHERE '.implode(' AND ',$where);

	$sql.= " ORDER by name";

	$database->setQuery($sql, $limitstart, $limit);

	$items = $database->loadObjectList();



	HTML_strbm_admin::listTypes($items,$pageNav);

}



function strbmEditType($id) {

	global $database, $option, $mainframe;

	global $my;



	$row = new strbmObjType($database);

	$row->load( $id );



	HTML_strbm_admin::editType($row);

}



function strbmSaveType($id,$task) {

	global $database, $option,$my,$mainframe;

	

	$post	= JRequest::get( 'post' );

	

	$obj = new strbmObjType($database);

	$obj->load($id);

	

	if (!$obj->bind( $post, 'selections' )) {

		return JError::raiseWarning( 500, $obj->getError() );

	}



	if (!$obj->check()) {

		return JError::raiseWarning( 500, $obj->getError() );

	}



	if (!$obj->store()) {

		return JError::raiseWarning( 500, $obj->getError() );

	}

	$folder = JPATH_SITE.$GLOBALS["cfgstrbmap"]["images_path"];

	$upldError = '';

	$upldMarkerFile = $_FILES['upld']['tmp_name']['icon_name'];

	$upldShadowFile = $_FILES['upld']['tmp_name']['icon_shad_name'];

	if(is_file($upldMarkerFile)){

		$fName = $_FILES['upld']['name']['icon_name'];

		if(!eregi(".png$",$fName)) $upldError = _STRBM_ONLY_PNG;

		$newName = md5(uniqid(rand(), true)).'.png';

		if(is_file($folder.'/'.$obj->icon_name)) unlink($folder.'/'.$obj->icon_name);

		if(!copy($upldMarkerFile,$folder.'/'.$newName))	$upldError = _STRBM_IMG_COPY_ERROR;

		else{

			list($width, $height, $type, $attr) = getimagesize($upldMarkerFile);

			$obj->icon_name = $newName;

			$obj->icon_size = $width.'x'.$height;

			$obj->store();

		}

	}

	if(is_file($upldShadowFile)){

		$fName = $_FILES['upld']['name']['icon_shad_name'];

		if(!eregi(".png$",$fName)) $upldError = _STRBM_ONLY_PNG;

		$newName = md5(uniqid(rand(), true)).'.png';

		if(is_file($folder.'/'.$obj->icon_shad_name)) unlink($folder.'/'.$obj->icon_shad_name);

		if(!copy($upldShadowFile,$folder.'/'.$newName))	$upldError = _STRBM_IMG_COPY_ERROR;

		else{

			list($width, $height, $type, $attr) = getimagesize($upldShadowFile);

			$obj->icon_shad_name = $newName;

			$obj->icon_shad_size = $width.'x'.$height;

			$obj->store();

		}

	}

	if($upldError!=''){

		$task = 'apply_type';

	}

	else{

		$upldError = _STRBM_TYPE_SAVED;

	}

	if($task=='apply_type') $mainframe->redirect( "index2.php?option=$option&task=edit_type&id=".$obj->id, $upldError );

	else $mainframe->redirect( "index2.php?option=$option&task=list_obj_types",_STRBM_TYPE_SAVED );

}



function strbmDelTypes( &$cid ) {

	global $database, $option, $mainframe;



	if (count( $cid ) < 1) {

		echo "<script> alert('" . _STRBM_SEL_OBJECTS . "'); window.history.go(-1);</script>\n";

		exit;

	}

	$pid = array(0);

	$folder = JPATH_SITE.$GLOBALS["cfgstrbmap"]["images_path"];

	foreach($cid as $id){

		$row = new strbmObjType($database);

		$row->load( $id );

		if(!$row->id) continue;

		$file = $folder.'/'.$row->icon_name;

		$file2 = $folder.'/'.$row->icon_shad_name;

		unlink($file);

		unlink($file2);

		$pid[] = $row->id;

	}

	$pids = implode( ',', $pid );

	$database->setQuery( "DELETE FROM #__strb_obj_types WHERE id IN ($pids)" );

	if (!$database->query()) {

		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";

	}



	$mainframe->redirect( "index2.php?option=$option&task=list_obj_types" );

}



####################################



function strbmCancel() {

	global $option,$mainframe;

	$returnpage = JRequest::getVar('returnpage', '');

	$mainframe->redirect( "index2.php?option=$option&task=$returnpage" );

}



function strbmSaveConfig() {

	global $database, $option, $mainframe;



	$cfgfile = JPATH_SITE.DS.'components'.DS.'com_gmap'.DS.'configuration.php';

	@chmod( $cfgfile, 0766 );

	if(!is_writable( $cfgfile)){

		$mainframe->redirect( "index2.php?option=$option&task=config", _STRBM_CONFIG_NOT_WRITABLE );

	}

	$txt = '<?php

$cfgstrbmap = array();

';

	$datas = JRequest::getVar('cfg', array(), 'post');

	foreach($datas as $key=>$val){

		$txt.= '$cfgstrbmap["'.$key.'"] = "'.$val.'";'."\r\n";

	}

	$txt.= '$GLOBALS["cfgstrbmap"] = $cfgstrbmap;';



	if ( $fp = fopen( $cfgfile, "w" ) ) {

		fputs( $fp, $txt, strlen( $txt ) );

		fclose( $fp );

	}

	else $mainframe->redirect( "index2.php?option=$option&task=config", _STRBM_CONFIG_NOT_WRITABLE );

	

	$mainframe->redirect( "index2.php?option=$option&task=config", _STRBM_CONFIG_SAVED );

}



